insert into documents (id, description, created_on, gml)
  values (
    document_sequence.nextval,
    'Top10NL doc w/spatial select',
    current_timestamp,
    xmltype('<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>' ||
      xmlelement("tdn:Top10Themas",
       xmlattributes('http://www.gdmc.nl/tdn' as "xmlns:tdn",
                      'http://www.opengis.net/gml' as "xmlns:gml",
                      'http://www.w3.org/1999/xlink' as "xmlns:xlink",
                      'http://www.w3.org/2000/10/XMLSchema-instance' as "xmlns:xsi",
                      'http://www.gdmc.nl/tdn tdn_strict2.1.xsd' as "xsi:schemaLocation"),
       xmlelement("gml:description", 'Created by Oracle - GML Relay - Emmen, Dec 13, 2002'),
       xmlelement("gml:boundedBy",
         xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
       ),
       xmlelement("tdn:top10ThemasMember",
         -- RuimtelijkeObjecten
         xmlelement("tdn:RuimtelijkeObjecten",
           xmlelement("gml:boundedBy",
             xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
           ),
           -- SpoorbaanDeel
           (select xmlagg(
              xmlelement("tdn:ruimtelijkeObjectenMember",
                xmlelement("tdn:SpoorbaanDeel", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id", top10_id),
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                    'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:type", type),
                  xmlelement("tdn:toegankelijkheid", TOEGANKELIJKHEID),
                  xmlelement("tdn:status", status),
                  xmlelement("gml:polygonProperty", xmltype(gmlutil.to_gmlgeometry(geometry))),
                  xmlelement("gml:geometryProperty", xmltype(gmlutil.to_gmlgeometry(geometryproperty))),
                  xmlelement("tdn:verkeersgebruik", VERKEERSGEBRUIK),
                  xmlelement("tdn:fysiek_voorkomen", FYSIEK_VOORKOMEN),
                  xmlelement("tdn:spoorbreedte", SPOORBREEDTE),
                  xmlelement("tdn:aantal_sporen", AANTAL_SPOREN),
                  xmlelement("tdn:elektrificatie", elektrificatie),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:naam", NAAM)
                )
              )
            )
            from spoorbaandeel
             where sdo_filter (
                     geometry,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           ),
           -- Wegdeel
           (select xmlagg(
              xmlelement("tdn:ruimtelijkeObjectenMember",
                xmlelement("tdn:WegDeel", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id",top10_id ) ,
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                    'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:type", type),
                  xmlelement("tdn:toegankelijkheid", TOEGANKELIJKHEID),
                  xmlelement("tdn:status", status),
                  xmlelement("gml:polygonProperty", xmltype(gmlutil.to_gmlgeometry(geometry))),
                  xmlelement("gml:geometryProperty",xmltype(gmlutil.to_gmlgeometry(geometryproperty))),
                  xmlelement("tdn:wegtype", wegtype),
                  xmlelement("tdn:hoofdverkeersgebruik", HOOFDVERKEERSGEBRUIK),
                  xmlelement("tdn:fysiek_voorkomen", FYSIEK_VOORKOMEN),
                  xmlelement("tdn:kruisingstype", KRUISINGSTYPE),
                  xmlelement("tdn:verhardingsbreedteklasse", VERHARDINGSBREEDTEKLASSE),
                  xmlelement("tdn:verhardingsbreedte", VERHARDINGSBREEDTE),
                  xmlelement("tdn:verhardingstype", VERHARDINGSTYPE),
                  xmlelement("tdn:verhardingsmateriaal", VERHARDINGSMATERIAAL),
                  xmlelement("tdn:aantal_rijstroken", AANTAL_RIJSTROKEN),
                  xmlelement("tdn:rijrichting", RIJRICHTING),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:straatnaam", STRAATNAAM),
                  xmlelement("tdn:wegnummer", WEGNUMMER)
                )
              )
            )
            from wegdeel
             where sdo_filter (
                     geometry,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           ),
           -- Waterdeel
           (select xmlagg(
              xmlelement("tdn:ruimtelijkeObjectenMember",
                xmlelement("tdn:WaterDeel", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id", top10_id),
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                     'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:type", type),
                  xmlelement("tdn:toegankelijkheid", TOEGANKELIJKHEID),
                  xmlelement("tdn:status", status),
                  xmlelement("gml:polygonProperty", xmltype(gmlutil.to_gmlgeometry(geometry))),
                  xmlelement("gml:geometryProperty", xmltype(gmlutil.to_gmlgeometry(geometryproperty))),
                  xmlelement("tdn:watertype", watertype),
                  xmlelement("tdn:breedteklasse", breedteklasse),
                  xmlelement("tdn:breedte", BREEDTE),
                  xmlelement("tdn:hoofdafwatering", hoofdafwatering),
                  xmlelement("tdn:zoutgehalte", zoutgehalte),
                  xmlelement("tdn:fysiek_voorkomen", FYSIEK_VOORKOMEN),
                  xmlelement("tdn:gebruik", gebruik),
                  xmlelement("tdn:stroomrichting", STROOMRICHTING),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:naam", NAAM)
                )
              )
            )
            from waterdeel
             where sdo_filter (
                     geometry,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           ),
           -- Terrein
           (select xmlagg(
              xmlelement("tdn:ruimtelijkeObjectenMember",
                xmlelement("tdn:Terrein", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id", top10_id),
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                    'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:landgebruik", landgebruik),
                  xmlelement("tdn:fysiek_voorkomen", FYSIEK_VOORKOMEN),
                  xmlelement("tdn:toegankelijkheid", TOEGANKELIJKHEID),
                  xmlelement("tdn:voorkomen", voorkomen),
                  xmlelement("gml:polygonProperty", xmltype(gmlutil.to_gmlgeometry(polygonproperty))),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:naam", NAAM)
                )
              )
            )
            from terrein
             where sdo_filter (
                     polygonproperty,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           )
         )
       ),
       xmlelement("tdn:top10ThemasMember",
         -- Gebouwen
         xmlelement("tdn:Gebouwen",
           xmlelement("gml:boundedBy",
             xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
           ),
           -- Gebouwen
           (select xmlagg(
              xmlelement("tdn:gebouwenMember",
                xmlelement("tdn:Gebouw", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id", top10_id),
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                    'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:type", type),
                  xmlelement("tdn:functie", functie),
                  xmlelement("tdn:hoogteklasse", hoogteklasse),
                  xmlelement("tdn:hoogte", hoogte),
                  xmlelement("tdn:status", status),
                  xmlelement("gml:geometryProperty",xmltype(gml_util.to_gmlgeometry(geometryProperty))),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:naam", NAAM)
                )
              )
            )
            from gebouw
             where sdo_filter (
                     geometryproperty,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           )
         )
       ),
       xmlelement("tdn:top10ThemasMember",
         -- InrichtingsElementen
         xmlelement("tdn:InrichtingsElementen",
           xmlelement("gml:boundedBy",
             xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
           ),
           -- InrichtingsElementen
           (select xmlagg(
              xmlelement("tdn:inrichtingsElementenMember",
                xmlelement("tdn:InrichtingsElement", xmlattributes(fid as "fid"),
                  xmlelement("tdn:top10_id", top10_id),
                  xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                    'metadata.xml#' || bronref as "xlink:href")),
                  xmlelement("tdn:object_begindatum", object_begindatum),
                  xmlelement("tdn:versienummer", versienummer),
                  xmlelement("tdn:versie_begindatum", versie_begindatum),
                  xmlelement("tdn:dimensie", dimensie),
                  xmlelement("tdn:tdncode", tdncode),
                  xmlelement("tdn:type", type),
                  xmlelement("tdn:functie", functie),
                  xmlelement("tdn:hoogte", hoogte),
                  xmlelement("tdn:status", status),
                  xmlelement("gml:geometryProperty",xmltype(gml_util.to_gmlgeometry(geometryProperty))),
                  xmlelement("tdn:hoogteniveau", HOOGTENIVEAU),
                  xmlelement("tdn:naam", NAAM),
                  xmlelement("tdn:nummer", NUMMER)
                )
              )
            )
            from InrichtingsElement
             where sdo_filter (
                     geometryproperty,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           )
         )
       ),
       xmlelement("tdn:top10ThemasMember",
         -- AdministratieveGebieden
         xmlelement("tdn:AdministratieveGebieden",
           xmlelement("gml:boundedBy",
             xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
           ),
           -- AdministratieveGebieden
           (select xmlagg(
              -- xmlelement("tdn:administratieveGebiedenMember", THIS NAME IS TOO LONG
              xmlelement("tdn:administratieveGebiedenMem",
                xmlelement("tdn:AdministratiefGebied", xmlattributes(fid as "fid"),
                   xmlelement("tdn:top10_id", top10_id),
                   xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                     'metadata.xml#' || bronref as "xlink:href")),
                   xmlelement("tdn:object_begindatum", object_begindatum),
                   xmlelement("tdn:versienummer", versienummer),
                   xmlelement("tdn:versie_begindatum", versie_begindatum),
                   xmlelement("tdn:dimensie", dimensie),
                   xmlelement("tdn:tdncode", tdncode),
                   xmlelement("tdn:type", type),
                   xmlelement("gml:geometryProperty",xmltype(gml_util.to_gmlgeometry(geometryProperty))),
                   xmlelement("tdn:naam", NAAM)
                )
              )
            )
            from AdministratiefGebied
             where sdo_filter (
                     geometryproperty,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           )
         )
       ),
       xmlelement("tdn:top10ThemasMember",
         -- GeografischeGebieden
         xmlelement("tdn:GeografischeGebieden",
           xmlelement("gml:boundedBy",
             xmltype(gmlutil.to_gmlgeometry (mdsys.sdo_geometry(2003, 90112, null, mdsys.sdo_elem_info_array(1,1003,3), mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100))) )
           ),
           -- GeografischeGebieden
            (select xmlagg(
               xmlelement("tdn:geografischeGebiedenMember",
                 xmlelement("tdn:GeografischGebied", xmlattributes(fid as "fid"),
                    xmlelement("tdn:top10_id", top10_id),
                    xmlelement("tdn:bronRef", xmlattributes('simple' as "xlink:type",
                      'metadata.xml#' || bronref as "xlink:href")),
                    xmlelement("tdn:object_begindatum", object_begindatum),
                    xmlelement("tdn:versienummer", versienummer),
                    xmlelement("tdn:versie_begindatum", versie_begindatum),
                    xmlelement("tdn:dimensie", dimensie),
                    xmlelement("tdn:tdncode", tdncode),
                    xmlelement("tdn:type", type),
                    xmlelement("gml:geometryProperty",xmltype(gml_util.to_gmlgeometry(geometryProperty))),
                    xmlelement("tdn:naam", NAAM)
                 )
               )
             )
             from geografischGebied
             where sdo_filter (
                     geometryproperty,
                     mdsys.sdo_geometry(2003, 90112, null,
                       mdsys.sdo_elem_info_array(1,1003,3),
                       mdsys.sdo_ordinate_array(158040, 432500, 158640, 433100)
                     ), 'querytype=window'
                   ) = 'TRUE'
           )
         )
       )
      ).getClobVal()
    )
  );
commit;
